/*---------------------------------------------------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/*---------------------------------------------------------------------*/

#include "usb.h"
#include "usb_req_class.h"
#include "string.h"
BYTE bHidIdle;
BYTE bKeyCode = 0;
BYTE bKeyDebounce = 0;
BOOL fKeyOK;

sbit LED_NUM        = P4^3;
sbit LED_CAPS       = P4^2;
sbit LED_SCROLL     = P4^1;

void usb_req_class()
{
    switch (Setup.bRequest)
    {
    case GET_REPORT:
        usb_get_report();
        break;
    case SET_REPORT:
        usb_set_report();
        break;
    case GET_IDLE:
        usb_get_idle();
        break;
    case SET_IDLE:
        usb_set_idle();
        break;
    case GET_PROTOCOL:
        usb_get_protocol();
        break;
    case SET_PROTOCOL:
        usb_set_protocol();
        break;
    default:
        usb_setup_stall();
        return;
    }
}

void usb_get_report()
{
    if ((DeviceState != DEVSTATE_CONFIGURED) ||
        (Setup.bmRequestType != (IN_DIRECT | CLASS_REQUEST | INTERFACE_RECIPIENT)))
    {
        usb_setup_stall();
        return;
    }

    Ep0State.pData = UsbBuffer;
    Ep0State.wSize = Setup.wLength;

    usb_setup_in();
}

void usb_set_report()
{
    if ((DeviceState != DEVSTATE_CONFIGURED) ||
        (Setup.bmRequestType != (OUT_DIRECT | CLASS_REQUEST | INTERFACE_RECIPIENT)))
    {
        usb_setup_stall();
        return;
    }

    Ep0State.pData = UsbBuffer;
    Ep0State.wSize = Setup.wLength;

    usb_setup_out();
}

void usb_get_idle()
{
    if ((DeviceState != DEVSTATE_CONFIGURED) ||
        (Setup.bmRequestType != (IN_DIRECT | CLASS_REQUEST | INTERFACE_RECIPIENT)))
    {
        usb_setup_stall();
        return;
    }

    Ep0State.pData = &bHidIdle;
    Ep0State.wSize = 1;

    usb_setup_in();
}

void usb_set_idle()
{
    if ((DeviceState != DEVSTATE_CONFIGURED) ||
        (Setup.bmRequestType != (OUT_DIRECT | CLASS_REQUEST | INTERFACE_RECIPIENT)))
    {
        usb_setup_stall();
        return;
    }

    bHidIdle = Setup.wValueH;

    usb_setup_status();
}

void usb_get_protocol()
{
    usb_setup_stall();
}

void usb_set_protocol()
{
    usb_setup_stall();
}

void usb_class_out()
{
    BYTE led;
    
    if (usb_bulk_intr_out(UsbBuffer, 1) == 1)
    {
        P4M0 &= ~0x0f;
        P4M1 &= ~0x0f;
        
        led = UsbBuffer[0];
        LED_NUM = !(led & 0x01);
        LED_CAPS = !(led & 0x02);
        LED_SCROLL = !(led & 0x04);
    }
}

// ɨ붨壨ʹñ׼PS/2ɨ룩
unsigned char get_keycode(unsigned char ch,u8* isNeedShitf) {
		*isNeedShitf = 0;
       // ĸ (A-Z)
    if (ch >= 'A' && ch <= 'Z') {
				*isNeedShitf  = 1;
        return 0x04 + (ch - 'A');  // AӦ0x04BӦ0x05Դ
    }
    
    // ĸ (a-z) - Сдʹͬɨ
    if (ch >= 'a' && ch <= 'z') {
        return 0x04 + (ch - 'a');  // aӦ0x04bӦ0x05Դ
    }
    
    // ּ (0-9)
    switch(ch) {
        case '0': return 0x27;
        case '1': return 0x1E;
        case '2': return 0x1F;
        case '3': return 0x20;
        case '4': return 0x21;
        case '5': return 0x22;
        case '6': return 0x23;
        case '7': return 0x24;
        case '8': return 0x25;
        case '9': return 0x26;
    }
    
    // ż
    switch(ch) {
        case ' ': return 0x2C;     // ո
        case '.': return 0x37;     // 
        case ',': return 0x36;     // 
        case ';': return 0x33;     // ֺ
        case '\'': return 0x34;    // 
        case '\\': return 0x31;    // б
        case '/': return 0x38;     // б
        case '[': return 0x2F;     // 
        case ']': return 0x30;     // ҷ
        case '-': return 0x2D;     // 
        case '=': return 0x2E;     // Ⱥ
        case '`': return 0x35;     // ˺
    }
    
    // ܼ
    switch(ch) {
        case '\r': return 0x28;    // س
        case '\t': return 0x2B;    // Tab
        case '\b': return 0x2A;    // ˸
    }
    
    // ַӳУ0
    return 0x00;
}
char*  msg1 = "fasongjianpan1AbC";
char*  msg2 = "fasongjianpan2AbC";
u8 msgCharIndex = 0;
char* sendMsg;
void sendChar(unsigned char c){
			BYTE i;
			BYTE key[8];
			u8 isNeedShitf;
			key[0] = 0;
			key[1] = 0;
			key[2] = 0;
			key[3] = 0;
			key[4] = 0;
			key[5] = 0;
			key[6] = 0;
			key[7] = 0;
			
			key[2] = get_keycode(c,&isNeedShitf);
			if(isNeedShitf){
				key[0] |= 0x02;
			}
			
			EUSB = 0;
			UsbInBusy = 1;
			usb_write_reg(INDEX, 1);
			for (i=0; i<8; i++)
			{
					usb_write_reg(FIFO1, key[i]);
			}
			usb_write_reg(INCSR1, INIPRDY);
			EUSB = 1;
}
void usb_class_in()
{
    if (DeviceState != DEVSTATE_CONFIGURED)
        return;

    if (!UsbInBusy && fKeyOK)
    {
        fKeyOK = 0;
				msgCharIndex = 0;
				if(bKeyCode == 0xfe){
						//0
					sendMsg = msg1;
				}
				if(bKeyCode == 0xfd){
						//1
					sendMsg = msg2;
				}
    }
		if(!UsbInBusy && sendMsg != NULL){
			if(msgCharIndex < strlen(sendMsg)){
				sendChar(sendMsg[msgCharIndex++]);
			}else{
				sendChar(0x00);
				sendMsg = NULL;
			}
		}
				
}

void scan_key()
{
    BYTE key;
    
    P0M0 = 0x00;
    P0M1 = 0x00;
    
    key = 0;
    P0 = 0xff;
    P06 = 0;
    _nop_();
    _nop_();
    key |= P0 & 0x0f;
    P06 = 1;
    P07 = 0;
    _nop_();
    _nop_();
    key |= (P0 & 0x0f) << 4;
    P07 = 1;
    
    if (key != bKeyCode)
    {
        bKeyCode = key;
        bKeyDebounce = 20;
    }
    else
    {
        if (bKeyDebounce)
        {
            bKeyDebounce--;
            if (bKeyDebounce == 0)
            {
                fKeyOK = 1;
            }
        }
    }
    
}

